(** Ackermann function **)

(* definition *)

fun ackermann 0 n = n + 1
  | ackermann m 0 = ackermann (m - 1) 1
  | ackermann m n = ackermann (m - 1) (ackermann m (n - 1));


(* examples *)

val a = ackermann 3 4;
val b = ackermann 3 5;
val c = ackermann 3 6;
